Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.beans
Class AttributeDefinition

    java.lang.Object
      oracle.ifs.beans.LibraryObjectDefinition
          oracle.ifs.beans.SchemaObjectDefinition
              oracle.ifs.beans.AttributeDefinition

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable

    public class AttributeDefinition

extends SchemaObjectDefinition

An `AttributeDefinition` is a template for creating an Attribute. Once you have created an attribute definition, add it to a ClassObjectDefition to create a custom subclass.

See Also:
  `Attribute`, `ClassObjectDefinition`, Serialized Form
(Published)

Field Summary
`static java.lang.String` | `DROP_COLUMN_SYSTEMOPTION_NAME` The name of the system option whose boolean AttributeValue controls whether, in removing an attribute from a ClassObject, that attribute's column in the base table is dropped or marked unused.
`static java.lang.String` | `EXISTING_COLUMN_SYSTEMOPTION_NAME` The name of the system option whose string AtributeValue is the name of an existing column in the base table for this attribute's ClassObject.
`static java.lang.String` | `EXISTING_INDEX_SYSTEMOPTION_NAME` The name of the system option whose string AttributeValue is the name of the index on the attribute's column in the ClassObject's base table.

Fields inherited from class oracle.ifs.beans.SchemaObjectDefinition
`m_CategoryDefs`

Fields inherited from class oracle.ifs.beans.LibraryObjectDefinition
`m_Attributes, m_ClassObjectName, m_ClassObjectValue, m_ContentSpecifications, m_DefinitionLists, m_Definitions, m_EnclosedDefinition, m_Id, m_Options, m_ReadOnly, m_ReferenceAttributes, m_Session, m_SystemOptions`

Constructor Summary
`AttributeDefinition(LibrarySessionInterface session)` Construct a definition explicitly capturing the session.
`AttributeDefinition(LibrarySessionInterface session, java.lang.String className)` Construct a definition, explicitly capturing the session and setting the initial classobject.

Method Summary
`protected static AttributeDefinition[]` | `vectorToAttributeDefinitionArray(java.util.Vector vector)` Internal use only: Converts a vector of AttributeDefinitions to an AttributeDefinition array.

Methods inherited from class oracle.ifs.beans.SchemaObjectDefinition
`addCategoryDefinition, addCategoryDefinitions, getCategoryDefinitions, removeCategoryDefinitions, setCategoryDefinitions, toSchemaObjectDefinition, toSchemaObjectDefinition`

Methods inherited from class oracle.ifs.beans.LibraryObjectDefinition
`addDefinition, addDefinitions, addProperty, addPropertyDefinition, addPropertyDefinitions, captureSession, captureSession, captureSession, clone, constructInstance, constructInstance, copyInto, getAttribute, getAttribute, getAttributes, getAttributes, getAttributesSorted, getClassId, getClassObject, getClassObjectValue, getContentSpecification, getContentSpecificationKeys, getCopiedObjectValue, getDefinition, getDefinitionClassName, getDefinitionKeys, getDefinitionListKeys, getDefinitions, getId, getLibrarySession, getName, getOption, getOptionAsAttributeValue, getOptionKeys, getPolicyMode, getPropertyDefinitions, getReferenceAttribute, getReferenceAttributes, getServerDefinition, getSession, getSLibrarySession, getStringAttribute, getSystemOption, getSystemOptionAsAttributeValue, getSystemOptionAsBoolean, getSystemOptionKeys, getWriteableInstance, isReadOnly, prepareForDefinitionObject, removeAttribute, removeContentSpecification, removeDefinition, removeDefinitions, removeOption, removePropertyDefinitions, removeReferenceAttribute, removeSystemOption, reset, resolve, setAttribute, setAttribute, setAttribute, setAttributeByUpperCaseName, setAttributeByUpperCaseName, setAttributePolicyMode, setAttributes, setClassId, setClassname, setClassObject, setClassObjectValue, setContentSpecification, setCopiedObjectValue, setDefinition, setDefinitions, setId, setName, setOption, setReadOnly, setReferenceAttribute, setReferenceAttribute, setSession, setSystemOption, unresolve, verifySession`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### EXISTING_COLUMN_SYSTEMOPTION_NAME

    public static final java.lang.String EXISTING_COLUMN_SYSTEMOPTION_NAME

  Description copied from class: `AttributeDefinition`
  The name of the system option whose string AtributeValue is the name of an existing column in the base table for this attribute's ClassObject.

  If this system option is specified in the AttributeDefinition used to add an attribute to an existing ClassObject, then the repository will use the existing column to store the new attribute's values, rather than the default behavior of adding a new column. It is the caller's responsibility to ensure the system option's value identifies a column that already exists and whose definition and properties are compatible with the new attribute. If the existing column has a name different than the DATABASEOBJECTNAME of the new attribute, the existing column is automatically renamed.

  See Also:
    Constant Field Values
  (Unpublished)

### EXISTING_INDEX_SYSTEMOPTION_NAME

    public static final java.lang.String EXISTING_INDEX_SYSTEMOPTION_NAME

  Description copied from class: `AttributeDefinition`
  The name of the system option whose string AttributeValue is the name of the index on the attribute's column in the ClassObject's base table.

  If this system option is specified in the AttributeDefinition used to add an attribute to an existing ClassObject, then the repository will use the existing index, rather than the default behavior of creating a new index. It is the caller's responsibility to ensure the system option's value identifies an index that already exists and whose definition and properties are consistent with the new attribute. The existing index will be renamed to a name synthesized from the id of the new attribute.

  See Also:
    Constant Field Values
  (Unpublished)

### DROP_COLUMN_SYSTEMOPTION_NAME

    public static final java.lang.String DROP_COLUMN_SYSTEMOPTION_NAME

  Description copied from class: `AttributeDefinition`
  The name of the system option whose boolean AttributeValue controls whether, in removing an attribute from a ClassObject, that attribute's column in the base table is dropped or marked unused.

  The default behavior is to drop the column (`ALTER TABLE ... DROP COLUMN`). However, if this system option is set false in the AttributeDefinition supplied in removing an attribute from a ClassObject, the repository will instead mark the column unused (`ALTER TABLE ... SET UNUSED COLUMN`).

  See Also:
    Constant Field Values
  (Unpublished)

Constructor Detail

### AttributeDefinition

    public AttributeDefinition(LibrarySessionInterface session)
                        throws IfsException

  Construct a definition explicitly capturing the session. The initial ClassObject will be Attribute.

  Parameters:
    `session` - the current session
  Throws:
    `IfsException` - if the operation fails
  (Published)

### AttributeDefinition

    public AttributeDefinition(LibrarySessionInterface session,
                               java.lang.String className)
                        throws IfsException

  Construct a definition, explicitly capturing the session and setting the initial classobject.

  Parameters:
    `session` - the current session
    `className` - the initial class name
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

Method Detail

### vectorToAttributeDefinitionArray

    protected static AttributeDefinition[] vectorToAttributeDefinitionArray(java.util.Vector vector)
                                                                     throws IfsException

  Description copied from class: `AttributeDefinition`
  Internal use only: Converts a vector of AttributeDefinitions to an AttributeDefinition array.

  For internal use only. Do not use this method.

  Parameters:
    `vector` - the vector
  Returns:
    the array
  Throws:
    `IfsException` - if an error occurs
  (Unpublished)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD